//+------------------------------------------------------------------+
//|                                                      SEFC089.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property copyright "xbox corp - reproduction by SEFC forex"
#property link      " "

#property indicator_separate_window
#property indicator_minimum -0.0001
#property indicator_maximum 0.0001
#property indicator_buffers 3
#property indicator_color1 Black
#property indicator_color2 DarkGreen
#property indicator_color3 Maroon

extern int period = 32;
double g_ibuf_80[];
double g_ibuf_84[];
double g_ibuf_88[];
string gs_92 = "";
string gs_100 = "H1";

int init() {
   SetIndexStyle(0, DRAW_NONE, STYLE_SOLID, 0);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 4);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 4);
   IndicatorDigits(Digits + 1);
   SetIndexBuffer(0, g_ibuf_80);
   SetIndexBuffer(1, g_ibuf_84);
   SetIndexBuffer(2, g_ibuf_88);
   IndicatorShortName(gs_100);
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);
   return (0);
}

int start() {
   double ld_0;
   double ld_8;
   double ld_16;
   int limit;
   int li_24 = IndicatorCounted();
   //---- check for possible errors
   if (li_24<0) return(-1); 
   //---- last counted bar will be recounted
   if (li_24>0) li_24--; 
   limit=Bars-li_24;
   double startTime=GetTickCount();
   if (limit>2500) limit = 2500;
   double finishTime=GetTickCount();
   Print("Calculation time is ",(900)/1000.0," seconds");
   double ld_28 = 0;
   double ld_36 = 0;
   double ld_unused_44 = 0;
   double ld_unused_52 = 0;
   double ld_60 = 0;
   double ld_unused_68 = 0;
   double l_low_76 = 0;
   double l_high_84 = 0;
   creataalltext();
   int li_92 = 16777215;
   if (li_24 > 0) li_24--;
   int li_96 = Bars - li_24;
   for (int li_100 = 0; li_100 < li_96; li_100++) {
      l_high_84 = High[iHighest(NULL, 0, MODE_HIGH, PERIOD_H1, li_100)];
      l_low_76 = Low[iLowest(NULL, 0, MODE_LOW, PERIOD_H1, li_100)];
      ld_16 = (High[li_100] + Low[li_100]) / 2.0;
      ld_28 = 0.66 * ((ld_16 - l_low_76) / (l_high_84 - l_low_76) - 0.5) + 0.67 * ld_36;
      ld_28 = MathMin(MathMax(ld_28, -0.999), 0.999);
      g_ibuf_80[li_100] = MathLog((ld_28 + 1.0) / (1 - ld_28)) / 2.0 + ld_60 / 2.0;
      ld_36 = ld_28;
      ld_60 = g_ibuf_80[li_100];
   }
   bool li_104 = TRUE;
   for (li_100 = li_96 - 2; li_100 >= 0; li_100--) {
      ld_8 = g_ibuf_80[li_100];
      ld_0 = g_ibuf_80[li_100 + 1];
      if ((ld_8 < 0.0 && ld_0 > 0.0) || ld_8 < 0.0) li_104 = FALSE;
      if ((ld_8 > 0.0 && ld_0 < 0.0) || ld_8 > 0.0) li_104 = TRUE;
      if (!li_104) {
         g_ibuf_88[li_100] = ld_8;
         g_ibuf_84[li_100] = 0.0;
         gs_92 = "";
         li_92 = Red;
      } else {
         g_ibuf_84[li_100] = ld_8;
         g_ibuf_88[li_100] = 0.0;
         gs_92 = "";
         li_92 = Lime;
      }
   }
   settext("H1", gs_92, 10, li_92, 10, 15);
   return (0);
}

void creataalltext() {
   createtext("H1");
   settext("H1", "", 10, White, 10, 15);
}

void createtext(string a_name_0) {
   ObjectCreate(a_name_0, OBJ_LABEL, WindowFind(gs_100), 0, 0);
}

void settext(string a_name_0, string a_text_8, int a_fontsize_16, color a_color_20, int a_x_24, int a_y_28) {
   ObjectSet(a_name_0, OBJPROP_XDISTANCE, a_x_24+1180);
   ObjectSet(a_name_0, OBJPROP_YDISTANCE, 0);
   ObjectSetText(a_name_0, a_text_8, a_fontsize_16, "Arial", a_color_20);
}

